package com.yao.gateway.cache;

import com.yao.gateway.cache.abs.GatewayNodeAbstract;
import lombok.extern.log4j.Log4j2;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @Author: LiJiaYao
 * @Date: 2024/4/18
 * @Description: 网关算法缓存
 */
@Component
@Log4j2
public class GatewayArithmeticCache extends GatewayNodeAbstract {

    private static final String loadNode ="work:node:gateway";
    private static final String cursor ="cursor";
    /**
     * 计数器
     */
    public void count(){
        redisService.setCacheObject(cursor, 0);
    }

    /**
     * 自增
     * @return 把这个值自增
     */
    public Long increment(){
        return redisService.increment(cursor, 1L);
    }
    /**
     * 删除loadNode的值
     */
    public void remove(){
        redisService.deleteObject(loadNode);
    }

    /**
     * 存储数据
     * @param loadNodeList 节点数据
     */
    public void loadNode(List<String> loadNodeList){
        redisService.setCacheList(loadNode, loadNodeList);
    }

    /**
     * 获取list信息
     * @param count 传入的数据
     * @return nodeId
     */
    public String cacheList(Long count){
         return redisService.getCacheList(loadNode, count % 100);
    }
}

