package com.yao.gateway.cache;

import com.aliyun.teautil.Common;
import com.yao.common.domain.aliy.InstanceInfo;
import com.yao.gateway.cache.abs.GatewayNodeAbstract;
import org.springframework.stereotype.Component;

import java.util.Set;

/**
 * @Author: LiJiaYao
 * @Date: 2024/4/18
 * @Description: 网关节点存储vin详情
 */
@Component
public class GatewayNodeSetVinCache extends GatewayNodeAbstract {
    /**
     * 阿里云键
     */
    private static final String realKey ="new:real:column";

    /**
     * 添加阿里云实列
     * @param infos 实例信息
     */
    public void newInstance(InstanceInfo infos){
        redisService.setCacheSet(realKey,infos);
    }

    /**
     * 取出实例数据
     * @param realKey 键名称
     * @return 相关实例数据值
     */
    public Set<InstanceInfo> get(){
        return redisService.getCacheSet(realKey);
    }

    /**
     * 删除这个key其中的一个数据
     * @param realKey new:real:column键
     * @param info 对应的值
     */
    public void remote(InstanceInfo info){
        redisService.deleteCacheMapValue(realKey, Common.toJSONString(info));
    }
}
