package com.yao.gateway.cache;

import com.yao.gateway.cache.abs.GatewayNodeAbstract;
import org.springframework.stereotype.Component;

import java.util.Set;

/**
 * @Author: LiJiaYao
 * @Date: 2024/4/18
 * @Description: 网关连接车俩
 */
@Component
public class GatewayVehicleLineNodeCache extends GatewayNodeAbstract {

    private final static String reconnectCar = "reconnectCar";

    /**
     * 把数据存入数据
     * @param ip ip地址
     */
    public void save(String ip){
        redisService.setCacheSet(reconnectCar,ip);
    }

    /**
     * 存储ip地址数据
     * @param ip ip地址
     */
    public void address(String ip) {
        redisService.setCacheSet("ECS", ip);
    }

    /**
     * 获取存储ecs的ip
     */
    public Set<String> getAddress() {
       return redisService.getCacheSet("ECS");
    }




}
