package com.yao.server.controller;

import com.yao.common.config.Result;
import com.yao.server.service.GatewayLoadService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Author: LiJiaYao
 * @Date: 2024/4/18
 * @Description: 网关控制层
 */
@RestController("/gateway")
@Log4j2
public class GatewayController {

    @Autowired
    private GatewayLoadService gatewayLoadService;

    @GetMapping("/load/node")
    public Result<String> loadNode(){
        return Result.success(gatewayLoadService.loadNode());
    }



}
