package com.yao.server.service.impl;

import com.yao.gateway.cache.GateWayNodeInfo;
import com.yao.gateway.cache.GatewayLoadNodeCache;
import com.yao.gateway.cache.GatewayLoadSeriesCache;
import com.yao.gateway.cache.GatewayNodeCache;
import com.yao.server.service.GatewayLoadService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

/**
 * @Author: LiJiaYao
 * @Date: 2024/4/18
 * @Description: 网关实现层
 */
@Service
@AllArgsConstructor
public class GatewayLoadServiceImpl implements GatewayLoadService {

    private final Long nodeLength = 100L;

    //网关负载节点缓存
    private final GatewayLoadNodeCache gatewayLoadNodeCache;
    //网关负载序列
    private final GatewayLoadSeriesCache gatewayLoadSeriesCache;
    //网关节点缓存
    private final GatewayNodeCache gatewayNodeCache;


    @Override
    public String loadNode() {
        //序列负载下标
        Long series = gatewayLoadSeriesCache.incrementAndGet();
        Long seriesLoadIndex = series % nodeLength;
        //获取对应下表的节点
        String loadNodeId = gatewayLoadNodeCache.getByIndex(seriesLoadIndex);
        //获取节点信息
        GateWayNodeInfo gateWayNodeInfo = gatewayNodeCache.get(loadNodeId);
        //获取外网ip
        return gateWayNodeInfo.getPublicIdAddress();
    }
}
