package com.yao.server.test;

import com.aliyun.ecs20140526.models.DescribeAvailableResourceRequest;
import com.aliyun.ecs20140526.models.DescribeAvailableResourceResponse;
import com.aliyun.tea.TeaException;
import com.aliyun.tea.TeaModel;

/**
 * @Author: LiJiaYao
 * @Date: 2024/4/12
 * @Description:
 */
public class Test {

    public static void main(String[] args_) throws Exception {
        // 地域Id
        String regionId = "cn-shanghai";
        // 要查询的资源类型。取值范围：
        // Zone：可用区。
        // IoOptimized：I/O 优化。
        // InstanceType：实例规格。
        // SystemDisk：系统盘。
        // DataDisk：数据盘。
        // Network：网络类型。
        // ddh：专有宿主机。
        String destinationResource = "InstanceType";
        // 是否为I/O优化实例
        // optimized：I/O优化
        // none：非IO优化
        String ioOptimized = "optimized";
        // 实例规格
        String instanceType = "ecs.e-c1m1.large";
//        Client client = ClientService.createEcsClient(regionId);
        // 查询指定地域下所有可用区的库存供应情况
//        Test.describeAvailableResource(client, regionId, destinationResource, ioOptimized, instanceType);
    }

    /**
     * DescribeAvailableResource    查询指定地域下所有可用区的库存供应情况
     */
    public static void describeAvailableResource(com.aliyun.ecs20140526.Client client, String regionId, String destinationResource, String ioOptimized, String instanceType) throws Exception {
        System.setOut(new java.io.PrintStream(System.out, true, "UTF-8"));
        DescribeAvailableResourceRequest request = new DescribeAvailableResourceRequest()
                .setRegionId(regionId)
                .setDestinationResource(destinationResource)
                .setIoOptimized(ioOptimized)
                .setInstanceType(instanceType);
        try {
            com.aliyun.teaconsole.Client.log("--------------------查询" + regionId + "地域下所有可用区的" + instanceType + "库存供应情况：--------------------");
            DescribeAvailableResourceResponse responces = client.describeAvailableResource(request);
            com.aliyun.teaconsole.Client.log("--------------------查询结果:" + com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(responces.body.availableZones)) + "--------------------");
        } catch (TeaException error) {
            com.aliyun.teaconsole.Client.log("--------------------查询失败:" + com.aliyun.teautil.Common.toJSONString(error.message) + "--------------------");
        } catch (Exception _error) {
            TeaException error = new TeaException(_error.getMessage(), _error);
            com.aliyun.teaconsole.Client.log("--------------------查询失败:" + com.aliyun.teautil.Common.toJSONString(error.message) + "--------------------");
        }
    }


}
