package com.yao;

import com.yao.common.redis.service.RedisService;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.extern.log4j.Log4j2;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.*;
import java.util.concurrent.CountDownLatch;

/**
 * @Author: LiJiaYao
 * @Date: 2024/4/14
 * @Description:
 */
@Log4j2
@SpringBootTest(classes = APISpringBootApplication.class)
public class LoadService1 {

    @Test
    public void load() {
        //初始化序列
//        redisService.setCacheObject("cursor",0);

        List<WorkGateWayNode> nodeIdList = new ArrayList() {
            {
                add(new WorkGateWayNode("work-gateway-node-1", 8));
                add(new WorkGateWayNode("work-gateway-node-2", 12));
                add(new WorkGateWayNode("work-gateway-node-3", 2));
                add(new WorkGateWayNode("work-gateway-node-4", 39));
                add(new WorkGateWayNode("work-gateway-node-5", 39));
            }
        };
        //100
        List<String> loadNodeList = new ArrayList<>();

        long count = nodeIdList.stream().mapToInt(WorkGateWayNode::getWeight).sum();
        if (count < 100) {
            List<WorkGateWayNode> list = nodeIdList.stream()
                    .sorted(((o1, o2) -> o2.getWeight() - o1.getWeight()))
                    .toList();
            int countWeight = 0;
            for (long i = count; i < 100; i++) {
                WorkGateWayNode workGateWayNode = list.get(countWeight++ % list.size());
                workGateWayNode.setWeight(workGateWayNode.getWeight() + 1);
            }
        }
        work:while (true) {
            for (WorkGateWayNode workGateWayNode : nodeIdList) {
                int weight = workGateWayNode.getWeight();
                if (weight > 0) {
                    loadNodeList.add(
                            workGateWayNode.getNodeId()
                    );
                    workGateWayNode.setWeight(weight - 1);
                }
                int intStream = nodeIdList.stream()
                        .mapToInt(WorkGateWayNode::getWeight)
                        .sum();
                if (intStream <= 0) {
                    break work;
                }
            }
        }

//        for (int i = 0; i < 100; i++) {
//            loadNodeList.add(
//                    nodeIdList.get(i%nodeIdList.size()).getNodeId()
//            );
//        }
//        for (int i = 0; i < 100; i++) {
//            loadNodeList.add(nodeIdList.get(i % nodeIdList.size()));
//        }
//        redisService.deleteObject("work:node:gateway");
//        redisService.setCacheList("work:node:gateway",loadNodeList);
        CountDownLatch countDownLatch = new CountDownLatch(300);
        new Thread(()->{
            for (int i = 0; i < 100; i++) {
//                Long cursor = redisService.increment("cursor", 1L);
//                String cacheList = redisService.getCacheList("work:node:gateway", cursor % 100);
//                log.info(cursor+"---------"+cacheList);
//                SitNode.sti(cacheList);
                countDownLatch.countDown();
            }
        }).start();
        new Thread(()->{
            for (int i = 0; i < 100; i++) {
//                Long cursor = redisService.increment("cursor", 1L);
//                String cacheList = redisService.getCacheList("work:node:gateway", cursor % 100);
//                log.info(cursor+"---------"+cacheList);
//                SitNode.sti(cacheList);
                countDownLatch.countDown();
            }
        }).start();
        new Thread(()->{
            for (int i = 0; i < 100; i++) {
//                Long cursor = redisService.increment("cursor", 1L);
//                String cacheList = redisService.getCacheList("work:node:gateway", cursor % 100);
//                log.info(cursor+"---------"+cacheList);
//                SitNode.sti(cacheList);
                countDownLatch.countDown();
            }
        }).start();
        try {
            countDownLatch.await();
            SitNode.show();
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

}

@Data
@AllArgsConstructor
class WorkGateWayNode {

    private String nodeId;
    private int weight;

}

//计数
@Log4j2
class SitNode{

    private static Map<String,Integer> sitNodeMap=new HashMap<>();
    public synchronized static void sti(String nodeId){
        Integer orDefault = sitNodeMap.getOrDefault(nodeId, 0);
        sitNodeMap.put(nodeId,orDefault+1);
    }
    public static void show(){
        sitNodeMap.forEach((key,val)->{
            log.info(key + "-------" +val);
        });
    }

}
